# mrise.bas                  22 Oct 2013
#  Moon Rise
#  Eric Burgess
#    from Astronomy on Your Computer
10 clear
20 dim P$(4)
30 let FR = .01745329
40 let FD = 57.299578
50 let LA = 38.24
60 let LO = 122.49
70 print "    moonrise"
80 print
90 print " initial lat and long:"
100 print "    lat  : ";LA
110 print "    long : ";LO
120 print
130 print "want to change them (y/n) ?:";
140 input B$
150 print B$
340 if B$ <> "Y" then goto 410
350 print "enter latitude ";
360 input LA
370 print LA
380 print "enter longitude ";
390 input LO
400 print LO
410 print
460 print "enter the date"
480 print "   year: ";
490 input Y
500 print Y
520 print "   month: ";
530 input M
540 print M
545 if M < 1 or M > 12 then goto 520
550 print "   day: ";
580 input DY
590 print DY
600 if DY < 1 or DY > 31 then goto 550
610 if M=2 and DY > 29 then goto 520
630 let DX = DY
640 let MX = M
650 let YX = Y
660 let DY = DY + (LO/15)/24
670 let DG = 365*Y+DY+((M-1)*31)
680 if M >=3 then goto 710
690 let DG = DG+ int((Y-1)/4)- int((.75)* int ((Y-1)/100+1))
700 goto 730
710 let DG = DG- int(M*.4+2.3)+ int(Y/4)
720 let DG = DG- int((.75)* int((Y/100)+1))
730 let NI = DG - 715875
740 REM get s.t.
750 gosub 1580
760 goto 1240
770 cls
780 fast
790 gosub 1000
800 slow
810 print
820 print "data requested for ";yx;" ";mx;" ";dx
830 print "-:-:-:-:-:-:-:-:-:-:-:-:-:-:-"
840 if ci=3 then print tab 22;"r.a. dec"
850 if ci=3 then print tab 22;"hrs  deg"
860 if ci=3 then goto 890
870 print "         hel. dist.  r.a. dec"
880 print "         lang. a.u.  hrs  deg"
890 print "-:-:-:-:-:-:-:-:-:-:-:-:-:-:-"
900 gosub 1710
910 print 
920 print "want copy y/n?"
930 input c$
940 if c$="n" or c$="no" then goto 960
950 copy
960 cls
970 print
980 print
990 goto 1870
1000 rem calc times
1010 let ta= tan (fr*la)* tan (fr*dm)
1020 if ta<0 then goto 1040
1030 if ta>0 then goto 1060
1040 let ta = abs(ta)
1050 goto 1070
1060 let ta=-ta
1070 let ta = acs (ta)
1080 let ta=fd*ta
1090 let b=-ta/15
1100 let tz = 0
1110 let tr=(b+rm+tz-t2)*.99727
1120 let tr=tr-1/60
1130 if tr<0 then let tr=tr+24
1140 if tr>24 then let tr=tr-24
1150 let c=ta/15
1160 let ts=(c+rm+tz-t2)*.99727
1170 let ts=ts+3/60
1180 if ts<0 then let ts=ts+24
1190 if ts>24 then let ts=ts-24
1200 let tt=rm-t2+1/60
1210 if tt<0 then let tt=tt+24
1220 if tt>24 then let tt=tt-24
1230 return
1240 rem rise, xsit, set of moon
1250 let lz=311.1687
1260 let le=178.699
1270 let lp=255.7433
1280 let pg=.111404*ni+lp
1290 let pg=(pg/360- int(pg/360))*360
1300 let lmd=lz+360*ni/27.32158
1310 let lmd=(lmd/360 - int (lmd/360))*360
1320 let pg=lmd-pg
1330 let dr=6.2886*sin(fr*pg)
1340 let lmd=lmd+dr
1350 let lmd=(lmd/360-int(lmd/360))*360
1360 let rm=lmd/15
1370 if rm>24 then let rm=rm-24
1380 if rm<0 then let rm=rm+24
1390 let al=le-ni*.052954
1400 let al=lmd-al
1410 let al=(al/360-int(al/360))*360
1420 let he=5.1454*sin(al*3.14159/180)
1430 let dm=he+23.1444*sin(lmd*3.14159/180)
1440 let r$=( str$(rm))( to 5)
1450 let d$=( str$(dm))( to 5)
1460 cls
1470 print
1480 print "moon data requested for..."
1490 print tab 4;"year ";yx;" month ";mx;" day ";dx
1500 print
1510 print "at noon"
1520 print "r.a. of moon is. ";r$;" hrs"
1530 print "declination is.. ";d$;" deg"
1540 print "-----------------------------"
1550 let p$="moon"
1560 gosub 1000
1570 goto 1720
1580 rem siderial time
1590 let gc=11.927485
1600 let tc=.065711
1610 let t2=tc*(ni-7020)+gc
1620 if t2<24 then goto 1650
1630 let t2=t2-24
1640 goto 1620
1650 if t2>-24 then goto 1680
1660 let t2=t2+24
1670 goto 1650
1680 if t2>0 then goto 1700
1690 let t2=t2+24
1700 return
1710 gosub 1000
1720 print
1730 print
1740 let tm=60*(tr-int(tr))
1750 let tr= int(tr)
1760 let tn=60*(tt-int(tt))
1770 let tt=int(tt)
1780 let tp=60*(ts-int(ts))
1790 let ts=int(ts)
1800 print
1810 print p$
1820 print "rises at .... ";tr;" hrs ";int(tm);" min"
1830 print "transits at . ";tt;" hrs ";int(tn);" min"
1840 print "sets at ..... ";ts;" hrs ";int(tp);" min"
1850 goto 910
1860 return
1870 print
1880 print "want another date y/n? ";
1890 input b$
1900 print b$
1910 if b$="n" then goto 1950
1920 let fl=0
1930 let f=0
1940 if b$="y" then goto 430
1950 cls
1960 stop
