# pstar.bas
#
10 cls
30 print at 4,5;"----------------------"
40 print at 5,5;"I       polaris      I"
50 print at 6,5;"----------------------"
100 print at 14,8;"provides times of"
110 print at 15,5;"elongations and transits"
120 print at 16,5;"of polaris for any date"
130 print at 17,8;"(within 10 minutes)"
140 print at 18,4;"for setting or checking the"
150 print at 19,4;"alignment of the polar axis"
160 print at 20,8;"of your telescope"
170 pause 350
180 let ly=0
190 cls
200 print
210 print "input year... ";
220 input y
230 print y
240 print
250 let y4 = y/4
260 let y5 = y/100
270 let y6 = y4-int(y4)
280 let y7=y5-int(y5)
290 if y6=0 and y7<>0 then let ly=1
300 print "     month.. ";
310 input m
320 print m
330 if m<1 or m>12 then goto 300
340 let d2=0
350 if m=2 then let d2=31
360 if m=3 then let d2=59
370 if m=4 then let d2=90
380 if m=5 then let d2=120
390 if m=6 then let d2=151
400 if m=7 then let d2=181
410 if m=8 then let d2=212
420 if m=9 then let d2=243
430 if m=10 then let d2=273
440 if m=11 then let d2=304
450 if m=12 then let d2=334
460 print
470 print tab 7;"day... ";
480 input d1
490 print d1
500 if d1<1 or d1>31 then goto 470
510 if m=2 and d1>29 then goto 470
520 if m=2 and d1>28 and ly=0 then goto 470
530 let d=d1+d2
540 if ly=1 and m>2 then let d=d+1
550 let g=y-1980
560 let yc=-.01638889*g
570 let gst=6.65422+yc
580 let dg=d*.0657096
590 let gt=gst+dg
600 if gt>24 then let gt=gt-24
610 if gt<0 then let gt=gt+24
620 print
630 print "  longitude... ";
640 input lo
650 print lo
660 pause 60
670 let cf=.065556*lo/360
680 let gt=gt+gt*cf
690 let ha=2.183333-gt
700 if ha<0 then let ha=ha+24
710 let mt=ha
720 let qd=5.98362
730 let qe=5.933333
740 let qw=5.933333
750 let ql=11.967222
760 cls
770 print
780 print
790 print
870 print tab 2;"  lower transit-next(5)"
880 print tab 2;"  upper transit-next(6)"
890 print
900 print
910 print "select by number ";
920 input s
930 print s
940 pause 100
950 cls
960 print at 6,0;"on ";y;" ";m;
970 print " ";d1;" longitude ";lo
980 print
990 if s=1 then goto 1130
1000 if s=2 then goto 1220
1010 if s=3 then goto 1320
1020 if s=4 then goto 1420
1030 if s=5 then goto 1520
1040 let nut=ha
1050 let in=nut
1060 gosub 1610
1070 gosub 1640
1080 let n$=str$ in
1090 print "next upper transit of polaris"
1100 print "will be at ";n$(1 to 5);" hrs"
1110 gosub 1690
1120 goto 1710
1130 let wn=mt+qw
1140 let in=wn
1150 gosub 1610
1160 gosub 1640
1170 let w$=str$ in
1180 print "next west elongation of polaris"
1190 print "will be at ";w$(1 to 5);" hrs"
1200 gosub 1690
1210 goto 1710
1220 let wp=mt-ql-qe
1230 let in=wp
1240 gosub 1610
1250 gosub 1640
1260 let p$=str$ in
1270 print "previous west elongation"
1280 print "of polaris"
1290 print "     was at ";p$(1 to 5);" hrs"
1300 gosub 1690
1310 goto 1710
1320 let en=mt+ql+qw
1330 let in=en
1340 gosub 1610
1350 gosub 1640
1360 let e$ = str$ in
1370 print "next east elongation"
1380 print "of polaris"
1390 print "will be at ";e$(1 to 5);" hrs"
1400 gosub 1690
1410 goto 1710
1420 let ep=mt-qw
1430 let in=ep
1440 gosub 1610
1450 gosub 1640
1460 let q$=str$ in
1470 print "previous east elongation"
1480 print "of polaris"
1490 print"     was at ";q$(1 to 5);" hrs"
1500 gosub 1690
1510 goto 1710
1520 let nlt=mt+ql
1530 let in=nlt
1540 gosub 1610
1550 gosub 1640
1560 let t$=str$ in
1570 print "next lower transit of polaris"
1580 print "will be at ";t$(1 to 5);" hrs"
1590 gosub 1690
1600 goto 1710
1610 if in>24 then let in=in-24
1620 if in<0 then let in=in+24
1630 return
1640 let in=in+in*.00273043
1650 let hm=int(in)
1660 let mi=60*(in-int(in))
1670 let m2=int(mi)
1680 return
1690 print
1700 print tab 8;" or ";hm;" hr ";m2;" mi"
1710 print 
1720 print "want another elongation"
1730 print " or transit y/n ";
1740 input a$
1750 print a$
1760 if a$="y" or a$="yes" then goto 760
1770 print
1780 print "want another day y/n ";
1790 input a$
1800 print a$
1810 if a$="y" or a$="yes" then goto 180
1820 cls
1830 stop

